# -*- coding: utf-8 -*-

#Copyright (C) 2008 Federico Mon Trotti, Daniel Tabas, Carlos Agra, Roberto Cano

#This file is part of HDLorean.
#
#HDLorean is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 2 of the License.

#HDLorean is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with HDLorean.  If not, see <http://www.gnu.org/licenses/>.

import sys
import os
import Preferences
import pygtk
import gtk
import gtk.glade
import gnome.ui
import gettext

## @brief Menu closes the app.
#
# Shows a menu with a button to close the main app.

class AddFileIncPattern:
	#class atribute to save pattern to add.
	global __includePattern
	__aux=""
	## The constructor.
	# The first is load in self->wTree.
	# The dictionaty connects the widget's signals with class functions.
	
	def __init__(self,__includePattern): #constructor
		APP='AddFileIncPattern'
		DIR='../../share/locale/'
		gettext.bindtextdomain(APP, DIR)
		gettext.textdomain(APP)
		_ = gettext.gettext
		gtk.glade.bindtextdomain(APP, DIR)
		gtk.glade.textdomain(APP)
		## @var gladefile
		# Variable wich contains the .glade file.
		self.gladefile="../../share/glade/HDLoreanAddFileIncPatternMenu.glade"
		## @var wTree
		# Contains the XML info of the .glade 
		self.wTree = gtk.glade.XML (self.gladefile)

		
		#diccionario: una tabla hash que se hace solita
		#sirve para conectar las señales que tira el gtk con las funciones q tratan
		dic = {"on_addIncButton_clicked" : self.addPattern,
			"on_cancelIncButton_clicked" : self.cancel,
			"on_entryFilePattern_changed" : self.readPattern
		}
		self.wTree.signal_autoconnect(dic)
		self.window=self.wTree.get_widget('addFileIncPattern')
		

	## @brief Add file pattern
	#
	# @param self The object pointer.
	# @param widget The type of the window.
	# @author Roberto Cano Fernandez	
	def addPattern(self,widget):
		# si añadimos lo guardamos en el atributo de clase
		__includePattern=self.__aux
		print "patron añadido :" + __includePattern
		self.window.destroy()
		return __includePattern

	## @brief Cancel method of the window
	#
	# @param self The object pointer.
	# @param widget The type of the window.
	# @author Roberto Cano Fernandez
	def cancel(self,widget):
		self.window.destroy()
	## @brief read pattern from entry
	#
	# @param self The object pointer.
	# @param widget The type of the window.
	# @author Roberto Cano Fernandez
	def readPattern(self,widget):
		## leer del entry
		self.__aux=str(self.wTree.get_widget('entryFilePattern').get_text())
		

	## @brief Method to return __pattern
	#
	#
	def returnPattern(self):
		return __includePattern
