# -*- coding: utf-8 -*-

#Copyright (C) 2008 Federico Mon Trotti, Daniel Tabas, Carlos Agra, Roberto Cano

#This file is part of HDLorean.
#
#HDLorean is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 2 of the License.

#HDLorean is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with HDLorean.  If not, see <http://www.gnu.org/licenses/>.

import sys
import os
import pygtk
import gtk
import gtk.glade
import gnome.ui
import gettext

## @brief Menu closes the app.
#
# Shows a menu with a button to close the main app.
class Close:
	## The constructor.
	# The first is load in self->wTree.
	# The dictionaty connects the widget's signals with class functions.	
	def __init__(self):
		APP='Close'
		DIR='../../share/locale/'
		gettext.bindtextdomain(APP, DIR)
		gettext.textdomain(APP)
		_ = gettext.gettext
		gtk.glade.bindtextdomain(APP, DIR)
		gtk.glade.textdomain(APP)
		## @var gladefile
		# Variable wich contains the .glade file.
		self.gladefile="../../share/glade/HDLoreanCloseMenu.glade"
		## @var wTree
		# Contains the XML info of the .glade 
		self.wTree = gtk.glade.XML (self.gladefile)
		dic = {	"on_closeCancButton_clicked" : self.Cancel,
			"on_closeExitButton_clicked" : self.Exit
		}
		self.wTree.signal_autoconnect(dic)	
		## @var window 
		# Contains the window object obtained by executing the wTree.get_widget() method.		
		self.window=self.wTree.get_widget('Close')
	## Cancels the exit of HDLorean.
	# @param self The object pointer.
	# @param widget The type of the window.	
	def Cancel(self,widget):
		self.window.destroy()
	## Exits from HDLorean
	# @param self The object pointer.
	# @param widget The type of the window.	
	def Exit(self,widget):
		self.window.destroy()
		sys.exit(0)
		gtk.main_quit()
