# -*- coding: utf-8 -*-

#Copyright (C) 2008 Federico Mon Trotti, Daniel Tabas, Carlos Agra, Roberto Cano

#This file is part of HDLorean.
#
#HDLorean is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 2 of the License.

#HDLorean is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with HDLorean.  If not, see <http://www.gnu.org/licenses/>.

import sys
import os
import FrontendProxy
import pygtk
import gtk
import gtk.glade
import gnome.ui
import gettext

## @brief Shows log of Database activities
#
# @author Carlos
class DBLog:
	## Treeview atributes
	# List of indexed directories & files
	__itemsAdded = []
	
	# Liststore & treeview for included directories & files
	__liststoreDB = gtk.ListStore(int,int,str,str,str,str,str)
	__treeviewDB = gtk.TreeView (__liststoreDB)
	def __init__(self): # DBLog Constructor
		APP='DBLog'
		DIR='../../share/locale/'
		gettext.bindtextdomain(APP, DIR)
		gettext.textdomain(APP)
		_ = gettext.gettext
		gtk.glade.bindtextdomain(APP, DIR)
		gtk.glade.textdomain(APP)
		self.__proxy = FrontendProxy.FrontendProxy()
		## @var gladefile
		# Variable wich contains the .glade file.
		self.gladefile="../../share/glade/HDLoreanDBLog.glade"
		## @var wTree
		# Contains the XML info of the .glade 
		self.wTree = gtk.glade.XML (self.gladefile)

		## Treeviews initializations
		# Prepare the renderers
		textrenderer = gtk.CellRendererText()
		# Include initializations
		self.__treeviewDB = self.wTree.get_widget('treeviewDB')
		self.__treeviewDB.set_model(self.__liststoreDB)
		self.__treeviewDB.set_headers_visible(True)
		# Add column 'ID' to the DB treeview
		header, col, renderer = 'ID', 0, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewDB.append_column(column)
		# Add column 'Timestamp' to the DB treeview
		header, col, renderer = 'Timestamp', 1, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewDB.append_column(column)
		# Add column 'Chtype' to the DB treeview
		header, col, renderer = 'Chtype', 2, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewDB.append_column(column)
		# Add column 'Btype' to the DB treeview
		header, col, renderer = 'Btype', 3, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewDB.append_column(column)
		# Add column 'Initpath' to the DB treeview
		header, col, renderer = 'Init path', 4, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewDB.append_column(column)
		# Add column 'Finalpath' to the DB treeview
		header, col, renderer = 'Final path', 5, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewDB.append_column(column)
		# Add column 'wrote' to the DB treeview
		header, col, renderer = 'Wrote', 6, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewDB.append_column(column)
		dic = {	"on_closeLogButton_clicked" : self.Close}
		self.wTree.signal_autoconnect(dic)	
		self.window=self.wTree.get_widget('DBLog')
		gobject.timeout_add(2000,self.refresh)
		# Write of the DB elements into the window
		listDB = self.__proxy.getInfo()
		row=[]
		for tupla in listDB:
			del row[:]
			for elem in tupla:
				row.append(elem)
			self.__liststoreDB.append(row)
	
	## @brief Function called in order to refresh the window
	#
	# @author Danieloop
	def refresh(self):
		listDB = self.__proxy.getInfo()
		row=[]
		for tupla in listDB:
			del row[:]
			for elem in tupla:
				row.append(elem)
			self.__liststoreDB.append(row)
		return True
	
	def Close (self,widget):
		#gtk.timeout_remove(self.refresh)
		self.window.destroy()
