# -*- coding: utf-8 -*-

#Copyright (C) 2008 Federico Mon Trotti, Daniel Tabas, Carlos Agra, Roberto Cano

#This file is part of HDLorean.
#
#HDLorean is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 2 of the License.

#HDLorean is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with HDLorean.  If not, see <http://www.gnu.org/licenses/>.

import urllib
import pygtk
import gtk
import gtk.glade
import thread
import os
import sys
import socket
import gettext

class DebugWindow:

	__gladefile = ''
	__trace = ''
	__comment = ''
	__textTrace = gtk.TextBuffer()
	__textviewTrace = gtk.TextView()
	__textviewMessage = gtk.TextView()
	__textMessage = gtk.Entry()


	def __init__(self,trace):
		APP='DebugWindow'
		DIR='../../share/locale/'
		gettext.bindtextdomain(APP, DIR)
		gettext.textdomain(APP)
		_ = gettext.gettext
		gtk.glade.bindtextdomain(APP, DIR)
		gtk.glade.textdomain(APP)
		self.__gladefile="../../share/glade/HDLoreanDebugWindow.glade"
		self.__trace = trace.replace("linea",'\n')
		# Load of glade file for the Log		
		self.wTree = gtk.glade.XML (self.__gladefile)
		# dictionary: connects the signals with the Main Window functions
		dic = { "on_sendButtonDebug_clicked" : self.sendDebugInfo,
			"on_cancelButtonDebug_clicked" : self.cancelDebugInfo
		}		
		self.wTree.signal_autoconnect (dic)
		self.__textTrace.set_text(self.__trace)
		self.window=self.wTree.get_widget('DebugWindow')
		style = self.window.get_style()
		__textviewTrace = self.wTree.get_widget('textviewTrace')
		__textviewTrace.modify_base(gtk.STATE_NORMAL, gtk.gdk.Color(red=57500, green=57500, blue=57500, pixel=45))
		__textMessage = self.wTree.get_widget('entryMessage')
		__textviewTrace.set_buffer(self.__textTrace)
		__textviewTrace.set_editable(False)

	def cancelDebugInfo(self,widget):
		self.window.destroy()
		sys.exit(0)
	
	def sendDebugInfo(self,widget):
		self.__textMessage = self.wTree.get_widget("entryMessage")
		self.__comment = self.__textMessage.get_text()

		# FIXME: Get this from HDLogger module
		file = open(os.getenv("HOME")+'/.hdlorean/logs/log','r')
		content = file.read()
		data = urllib.urlencode({"trace" : self.__trace, "comment" : self.__comment, "logfile" : content})
		socket.setdefaulttimeout(60)
		try:
			urllib.urlopen("http://www.hdlorean.com/bug_submit.php",data)
		except IOError:
			#
			#d = gtk.Dialog("Timeout Exceeded")
        		#d.set_border_width(4)
			#d.set_default_size(60,80)
		        #d.set_modal(False)
			#d.run()
			pass		
		file.close()	
		self.window.destroy()
		sys.exit(0)
