# -*- coding: utf-8 -*-

#Copyright (C) 2008 Federico Mon Trotti, Daniel Tabas, Carlos Agra, Roberto Cano

#This file is part of HDLorean.
#
#HDLorean is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 2 of the License.

#HDLorean is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with HDLorean.  If not, see <http://www.gnu.org/licenses/>.

import sys
import os
import TempLine
import FrontendProxy
import pygtk
import gtk
import gtk.glade
import gnome.ui
import gettext



## @brief Menu closes the app.
#
# Shows a menu with a button to close the main app.
class List:
	## The constructor.
	# The first is load in self->wTree.
	# The dictionaty connects the widget's signals with class functions.
	# Liststore & treeview for included directories & files
	__liststoreList = gtk.ListStore(str,str)
	__treeviewList = gtk.TreeView (__liststoreList)

	# List of indexed directories & files
	__itemsAdded = []
	# Instance of configfilemanager
	# TODO by Carlos: hacer una sola instancia para todas las ventanas

	def __init__(self): #constructora clase gui
		APP='List'
		DIR='../../share/locale/'
		gettext.bindtextdomain(APP, DIR)
		gettext.textdomain(APP)
		_ = gettext.gettext
		gtk.glade.bindtextdomain(APP, DIR)
		gtk.glade.textdomain(APP)
		self.__proxy = FrontendProxy.FrontendProxy()
		## @var gladefile
		# Variable wich contains the .glade file.
		self.gladefile="../../share/glade/HDLoreanListMenu.glade"
		## @var wTree
		# Contains the XML info of the .glade 
		self.wTree = gtk.glade.XML (self.gladefile)

		## Treeviews initializations
		# Prepare the renderers
		textrenderer = gtk.CellRendererText()
		# Include initializations
		self.__treeviewList = self.wTree.get_widget('treeviewList')
		self.__treeviewList.set_model(self.__liststoreList)
		self.__treeviewList.set_headers_visible(True)
		# Add backup name
		header, col, renderer = 'Name', 0, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewList.append_column(column)
		# Add modify date
		header, col,renderer = 'Modified', 1, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewList.append_column(column)
		# Add Size
		header, col, renderer = 'Size', 2, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		# Add where is the backup
		header, col, renderer = 'Where', 3, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)

		# Read indexed directories from the config file
		# TODO by Carlos: interpretar patrones para poner todos los archivos/directorios resultantes?
		if self.__proxy.hasSection("Lists"):
			if self.__proxy.hasOption("Lists","whitelist"):
				__aux=self.__proxy.getWhiteList()				
				__aux2=__aux.split(";")
				i=0
				if __aux2[0]!= "":
					while i<(len(__aux2)):
						self.__itemsAdded.append(__aux2[i])
						#TODO by Carlos: coger la fecha del último backup y ponerlo en lugar de "jarl"
						itt = self.__liststoreList.append([__aux2[i],"jarl"])				
						i=i+1

		#diccionario: una tabla hash que se hace solita
		#sirve para conectar las señales que tira el gtk con las funciones q tratan
		dic = {"on_viewListButton_clicked" : self.View
		}
		self.wTree.signal_autoconnect(dic)
		self.window=self.wTree.get_widget('List')
#################################################################################################################
	def Close(self,widget):
		self.window.destroy()
	def View(self,widget):
		#TODO by Carlos: cuando tengamos el archivo o directorio, pasárselo a TemLine para que muestre su info
		#De momento sólo llama a la ventana que hizo Tabas
		try:
			# Returns a (TreeModel, TreeIter) tuple
			model,itt = self.__treeviewList.get_selection().get_selected()		
			selection = self.__liststoreList.get_value(itt, 0)	
			print selection	
		except:
			print "There is no folder selected"
			pass
		app=TempLine.TempLine()
