# -*- coding: utf-8 -*-

#Copyright (C) 2008 Federico Mon Trotti, Daniel Tabas, Carlos Agra, Roberto Cano

#This file is part of HDLorean.
#
#HDLorean is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 2 of the License.

#HDLorean is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with HDLorean.  If not, see <http://www.gnu.org/licenses/>.

import pygtk
import gtk
import gtk.glade
import thread
import PyinotifyHandler
import os
import gettext

## @brief Shows log of inotify activities
#
# @author Carlos
class Log:
	__gladefile=os.getcwd()+"/gui/glade/HDLoreanLogMenu.glade"
	__text = gtk.TextBuffer()
	__textview = gtk.TextView()
	__inotify = None
	def __init__(self):
		APP='Log'
		DIR='../../share/locale/'
		gettext.bindtextdomain(APP, DIR)
		gettext.textdomain(APP)
		_ = gettext.gettext
		gtk.glade.bindtextdomain(APP, DIR)
		gtk.glade.textdomain(APP)
		# Load of glade file for the Log		
		self.wTree = gtk.glade.XML (self.__gladefile)
		# dictionary: connects the signals with the Main Window functions
		dic = { "on_closeLog_clicked" : self.closeButtonClicked,
			"on_Log_destroy" : self.exitDestroy
		}		
		self.wTree.signal_autoconnect (dic)
		__textview = self.wTree.get_widget('textviewLog')
		__textview.set_buffer(self.__text)
		self.wTree.signal_autoconnect(dic)	
		self.__inotify = PyinotifyHandler.PyinotifyHandler(self.getText())
		self.__inotify.startNotifier()
		# Contains the window object obtained by executing the wTree.get_widget() method.
		self.window=self.wTree.get_widget('Log')
		#gtk.gdk.threads_init()
		thread.start_new_thread(self.__inotify.startNotifier,())
	
	def closeButtonClicked(self,widget):
		#this is not working
		self.__inotify.stopNotifier()
		self.window.destroy()

	def exitDestroy(self,widget):
		self.__inotify.stopNotifier()

	def write(self,str):
		self.__text.insert_at_cursor(str)
		
	def getText(self):
		return self.__text
	
	

#l=Log()
#labrat = PyinotifyHandler.PyinotifyHandler(l.getText())
#labrat.startNotifier()

#gtk.main_iteration_do(False)
#gtk.main()
#gtk.gdk.threads_init()
#thread.start_new_thread(labrat.startNotifier,())
#gtk.gdk.threads_enter()
#gtk.main()
#gtk.gdk.threads_leave()
# keep artificially the main thread alive forever
#while True:
#	try:
#		import time
#		time.sleep(5)
#	except KeyboardInterrupt:
#		# ...until c^c signal
#		print 'stop monitoring...'
#		labrat.stopNotifier()
#		gtk.main_quit()
#		# stop monitoring
#		break
#	except Exception, err:
#		# otherwise keep on looping
#		print err		
		
