# -*- coding: utf-8 -*-

#Copyright (C) 2008 Federico Mon Trotti, Daniel Tabas, Carlos Agra, Roberto Cano

#This file is part of HDLorean.
#
#HDLorean is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#HDLorean is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with HDLorean.  If not, see <http://www.gnu.org/licenses/>.


import sys
import os
import FrontendProxy
import TempLineViewDiff
import pygtk
import gtk
import gtk.glade
import gnome.ui
import time
import calendar

## @brief Menu closes the app.
#
# Shows a menu with a button to close the main app.

class TempLine:
	## The constructor.
	# The first is load in self->wTree.
	# The dictionaty connects the widget's signals with class functions.
	# Liststore & treeview for included directories & files
	__liststoreTempLine = gtk.ListStore(str)
	__treeviewTempLine = gtk.TreeView (__liststoreTempLine)
	__path = ''
	__info = None
	__info2 = ''
	def __init__(self,selection): #constructora clase gui
		self.__proxy = FrontendProxy.FrontendProxy()
		self.__path = selection		
		## @var gladefile
		# Variable wich contains the .glade file.
		self.gladefile="../../share/glade/HDLoreanTempLine.glade"
		## @var wTree
		# Contains the XML info of the .glade 
		self.wTree = gtk.glade.XML (self.gladefile)

		## Treeviews initializations
		# Prepare the renderers
		textrenderer = gtk.CellRendererText()
		# Include initializations
		self.__treeviewTempLine = self.wTree.get_widget('treeviewTempLine')
		self.__treeviewTempLine.set_model(self.__liststoreTempLine)
		self.__treeviewTempLine.set_headers_visible(True)
		# Add column 'Path' to the include treeview
		header, col, renderer = 'Path', 0, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewTempLine.append_column(column)
		# Add number of version
		header, col,renderer = 'Version', 1, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewTempLine.append_column(column)
		# Add first date
		header, col,renderer = 'Backup Size', 2, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewTempLine.append_column(column)
		# Add last date
		header, col,renderer = 'First Backup', 3, textrenderer
		column = gtk.TreeViewColumn(header, renderer, text=col)
		column.set_sort_column_id(col)
		column.set_resizable(True)
		self.__treeviewTempLine.append_column(column)

		#diccionario: una tabla hash que se hace solita
		#sirve para conectar las señales que tira el gtk con las funciones q tratan
		dic = {"on_delete_clicked" : self.Delete,
			"on_revert_clicked" : self.Revert,
			"on_diff_clicked" : self.Diff,
			"on_accept_clicked" : self.Accept
		}
		self.wTree.signal_autoconnect(dic)
		self.window=self.wTree.get_widget('temporal')
		self.printpath = self.wTree.get_widget('path')
		self.printpath.set_text(self.__path)
		self.__getInfo()
		
	## @brief Method wich retrieves information of a path and displays it.
	#
	# @param self The object pointer
	# @author Danieloop 
	def __getInfo(self):
		#self.__info = self.__proxy.getFileInfo(calendar.timegm(time.localtime()),self.__path)
		##TODO de momento solo pido la info y hago un print, luego el tema seria meterlo en las columnas		
		#print self.__info
		self.__info2=self.__getHumanTimestamp(calendar.timegm(time.localtime()))
		print self.__info2
		
	##@brief Given a timestamp in history, the method returns a human readable string for it
	#
	#@param snapTimestamp timestamp to convert into
	#@return a human readable string for timestamp given
	def __getHumanTimestamp(self, snapTimestamp):
		# Get time
		notGMT, isDST = self.__proxy.getTimeAttributes(snapTimestamp)
		humanTimeStamp = time.gmtime(snapTimestamp - notGMT)
		humanTimeStamp = list(humanTimeStamp[0:6])
		timeFormat = '%02d-%02d-%02d %02d:%02d:%02d'
		# Calculates GMT difference and add it to timeString		
		if notGMT: 
			GMT = -(notGMT/3600)
			#timeFormat += ' GMT%+d' % GMT
		# If it is in DST, add it to timestring
		if isDST:
			timeFormat += ' (DST)'
			#humanTimeStamp[3] += 1
		timeString = timeFormat % tuple(humanTimeStamp)
		return timeString

	def Accept(self,widget):
		self.window.destroy()
	def Revert(self,widget):
		self.window.destroy()
	def Delete(self,widget):
		self.window.destroy()
	def Diff(self,widget):
		app= TempLineViewDiff.TempLineViewDiff()
		#self.window.destroy()
