# -*- coding: utf-8 -*-

#Copyright (C) 2008 David Molina

#This file is part of HDLorean.
#
#HDLorean is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#HDLorean is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with HDLorean.  If not, see <http://www.gnu.org/licenses/>.


from exceptions import *
##@brief
#
#Main exception class for de database module.
class DBError(Exception):
	pass


##@brief
#
#Exception that is launched when a mistake is detected in the sql query.
class SQLError(DBError):
	pass


##@brief
#
#Exception that is launched when there is a mistake of integrity in the database.
class IntegrityError(DBError):
	pass


##@brief
#
#Exception that is launched when there is no connection to the database.
class ConnError(DBError):
	pass
