# -*- coding: UTF-8 -*-

#Copyright (C) 2008 Salvador de la Puente

#This file is part of HDLorean.
#
#HDLorean is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#HDLorean is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with HDLorean.  If not, see <http://www.gnu.org/licenses/>.


import time
import calendar
import os
import string
import shutil
from stat import *
from db import History
from watcher import ConfigFileManager
from snapshotManager import IStorageWrapper

##@brief The module encapsulates functionality to make, restore and delete snapshots.
#
#
class Snapshot:
	##@brief The timestamp when the snapshot was done.
	__timestamp = None
	__snapshotWrapper = None
	__history = None

	##@brief The constructor of snapshots with a specified timestamp
	#
	#
	def __init__(self,timestamp):
		self.__timestamp = timestamp
		self.__snapshotWrapper = SnapshotManager.SnapshotManager()
		self.__history = History.History()


	def getUnixTimestamp(self):
		return self.__timestamp

	def getHumanTimestamp(self):
		dst = __history.wasDST(self.__timestamp)
		gmt = __history.whichGMT(self.__timestamp)
                return timestamp, gmt, dst

	def getTimeString(self):
		# If self.__timestamp is setted
		# Get GMT (difference beetwen time zone an Grenwich Time) and DST (day saving time, summer time)
		notGMT = int(__database.whichGMT(str(self.__timestamp)))
		isDST = int(__database.wasDST(str(self.__timestamp)))

		# Human readable TimeStamps
		humanTimeStamp = time.gmtime(self.__timestamp - notGMT)


		# Sets time-folder format
   		timeFormat = '%02d/%02d/%02d/%02d:%02d:%02d'
		timeString = timeFormat % humanTimeStamp[0:6]
		# Calculates GMT difference and add it to timeString                    
		if notGMT:
		        GMT = -(notGMT/3600)
		        timeString += 'GMT%+d' % GMT
		# If it is in DST, add it to timestring
		if isDST:
		        timeString += 'DST'

		return timeString

      
	
	def recoverSnapshot(self, recoverPath):
		return self.__snapshotManager (self.__timestamp, recoverPath)

	def recoverBackups(self, originalPathList, recoverPath):
		return self.__snapshtoManager(self.__timestamp,  originalPathList, recoverPath)

	




